#include <bits/stdc++.h>

using namespace std;

int a[500000];
stack<int> stak;

int main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    int br = 0, pom = k;
    stak.push(br);
    for(int i = 1; i < n; i++)
    {
        if(k <= 0)
            break;
        if(!stak.empty())
        {
        while(a[i] < a[stak.top()])
        {
            a[stak.top()] = -1;
            stak.pop();
            k--;
            if(k <= 0)
                break;
            if(stak.empty())
                break;
        }
        }
        stak.push(i);
    }
    int p = 0;
    for(int i = 0; i < n; i++)
    {
        if(p == n - pom)
            break;
        if(a[i] != -1)
        {
            p++;
            cout << a[i] << " ";
        }


    }
    return 0;
}